
//--------------------------------------˵-------------------------------------------
//		˵OpenCV3šOpenCV2鱾ʾ09
//		OpenCVװĿ¼SamplesļеĹٷʾ-ù˶Ŀ
//		òϵͳ Windows 7 64bit
//		IDE汾Visual Studio 2010
//		OpenCV汾	2.4.9
//		201411 Revised by @ǳī_ë
//------------------------------------------------------------------------------------------------


/************************************************************************
* Copyright(c) 2011  Yang Xian
* All rights reserved.
*
* File:	opticalFlow.cpp
* Brief: lk˶Ŀ
* Version: 1.0
* Author: Yang Xian
* Email: xyang2011@sinano.ac.cn
* Date:	2011/11/18
* History:
************************************************************************/


//---------------------------------ͷļռ֡----------------------------
//		ʹõͷļռ
//-------------------------------------------------------------------------------------------------
#include <opencv2/video/video.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <opencv2/imgproc/imgproc.hpp>
#include <opencv2/core/core.hpp>
#include <iostream>
#include <cstdio>

using namespace std;
using namespace cv;





//-----------------------------------ȫֺ-----------------------------------------
//		ȫֺ
//-------------------------------------------------------------------------------------------------
void tracking(Mat &frame, Mat &output);
bool addNewPoints();
bool acceptTrackedPoint(int i);

//-----------------------------------ȫֱ-----------------------------------------
//		ȫֱ
//-------------------------------------------------------------------------------------------------
string window_name = "optical flow tracking";
Mat gray;	// ǰͼƬ
Mat gray_prev;	// ԤͼƬ
vector<Point2f> points[2];	// point0Ϊԭλãpoint1Ϊλ
vector<Point2f> initial;	// ʼٵλ
vector<Point2f> features;	// 
int maxCount = 500;	// 
double qLevel = 0.01;	// ĵȼ
double minDist = 10.0;	// ֮С
vector<uchar> status;	// ״̬Ϊ1Ϊ0
vector<float> err;


//--------------------------------help( )----------------------------------------------
//		Ϣ
//-------------------------------------------------------------------------------------------------
static void help()
{
	//ӭϢOpenCV汾
	cout <<"\n\n\t\t\tǳлOpenCV3šһ飡\n"
		<<"\n\n\t\t\tΪOpenCV2ĵ9ʾ\n"
		<<	"\n\n\t\t\t   ǰʹõOpenCV汾Ϊ" << CV_VERSION 
		<<"\n\n  ----------------------------------------------------------------------------" ;
}


//-----------------------------------main( )--------------------------------------------
//		̨Ӧóںǵĳ￪ʼ
//-------------------------------------------------------------------------------------------------
int main()
{

	Mat frame;
	Mat result;

	VideoCapture capture("1.avi");

	help();
	if(capture.isOpened())	// ͷȡļ
	{
		while(true)
		{
			capture >> frame;

			if(!frame.empty())
			{ 
				tracking(frame, result);
			}
			else
			{ 
				printf(" --(!) No captured frame -- Break!");
				break;
			}

			int c = waitKey(50);
			if( (char)c == 27 )
			{
				break; 
			} 
		}
	}
	return 0;
}

//-------------------------------------------------------------------------------------------------
// function: tracking
// brief: 
// parameter: frame	Ƶ֡
//			  output иٽƵ֡
// return: void
//-------------------------------------------------------------------------------------------------
void tracking(Mat &frame, Mat &output)
{
	cvtColor(frame, gray, CV_BGR2GRAY);
	frame.copyTo(output);
	// 
	if (addNewPoints())
	{
		goodFeaturesToTrack(gray, features, maxCount, qLevel, minDist);
		points[0].insert(points[0].end(), features.begin(), features.end());
		initial.insert(initial.end(), features.begin(), features.end());
	}

	if (gray_prev.empty())
	{
		gray.copyTo(gray_prev);
	}
	// l-k˶
	calcOpticalFlowPyrLK(gray_prev, gray, points[0], points[1], status, err);
	// ȥһЩõ
	int k = 0;
	for (size_t i=0; i<points[1].size(); i++)
	{
		if (acceptTrackedPoint(i))
		{
			initial[k] = initial[i];
			points[1][k++] = points[1][i];
		}
	}
	points[1].resize(k);
	initial.resize(k);
	// ʾ˶켣
	for (size_t i=0; i<points[1].size(); i++)
	{
		line(output, initial[i], points[1][i], Scalar(0, 0, 255));
		circle(output, points[1][i], 3, Scalar(0, 255, 0), -1);
	}

	// ѵǰٽΪһ˲ο
	swap(points[1], points[0]);
	swap(gray_prev, gray);

	imshow(window_name, output);
}

//-------------------------------------------------------------------------------------------------
// function: addNewPoints
// brief: µǷӦñ
// parameter:
// return: Ƿӱ־
//-------------------------------------------------------------------------------------------------
bool addNewPoints()
{
	return points[0].size() <= 10;
}

//-------------------------------------------------------------------------------------------------
// function: acceptTrackedPoint
// brief: Щٵ㱻
// parameter:
// return:
//-------------------------------------------------------------------------------------------------
bool acceptTrackedPoint(int i)
{
	return status[i] && ((abs(points[0][i].x - points[1][i].x) + abs(points[0][i].y - points[1][i].y)) > 2);
}


